#version 120

#include "/lib/defines.glsl"

uniform float frameTimeCounter;
uniform mat4 gbufferModelView;
uniform mat4 gbufferProjectionInverse;
uniform sampler2D depthtex0;
uniform sampler2D gcolor;
uniform sampler2D noisetex;
uniform vec3 fogColor;

varying vec2 texcoord;

#include "/lib/noiseres.glsl"

#include "/lib/math.glsl"

#include "lib/calcFogColor.glsl"

void main() {
	vec3 color = texture2D(gcolor, texcoord).rgb;

	//no skybasic program in the nether. use deferred instead.
	#ifdef FOG_ENABLED_NETHER
		vec3 pos = vec3(texcoord, texture2D(depthtex0, texcoord).r);
		if (pos.z == 1.0) {
			vec4 v = gbufferProjectionInverse * vec4(pos * 2.0 - 1.0, 1.0);
			//pos = v.xyz / v.w;
			color = calcFogColor(normalize(v.xyz));
		}
	#endif

/* DRAWBUFFERS:0 */
	gl_FragData[0] = vec4(color, 1.0); //gcolor
}